# Custom Hostnames ## List Custom Hostnames `client.customHostnames.list(CustomHostnameListParamsparams, RequestOptionsoptions?): V4PagePaginationArray` **get** `/zones/{zone_id}/custom_hostnames` List, search, sort, and filter all of your custom hostnames. ### Parameters - `params: CustomHostnameListParams` - `zone_id: string` Path param: Identifier. - `id?: string` Query param: Hostname ID to match against. This ID was generated and returned during the initial custom_hostname creation. This parameter cannot be used with the 'hostname' parameter. - `certificate_authority?: "google" | "lets_encrypt" | "ssl_com"` Query param: Filter by the certificate authority that issued the SSL certificate. - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_origin_server?: string` Query param: Filter by custom origin server name. - `direction?: "asc" | "desc"` Query param: Direction to order hostnames. - `"asc"` - `"desc"` - `hostname?: Hostname` Query param - `contain?: string` Filters hostnames by a substring match on the hostname value. This parameter cannot be used with the 'id' parameter. - `hostname_status?: "active" | "pending" | "active_redeploying" | 13 more` Query param: Filter by the hostname's activation status. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `order?: "ssl" | "ssl_status"` Query param: Field to order hostnames by. - `"ssl"` - `"ssl_status"` - `page?: number` Query param: Page number of paginated results. - `per_page?: number` Query param: Number of hostnames per page. - `ssl?: 0 | 1` Query param: Whether to filter hostnames based on if they have SSL enabled. - `0` - `1` - `ssl_status?: "initializing" | "pending_validation" | "deleted" | 18 more` Query param: Filter by SSL certificate status. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `wildcard?: boolean` Query param: Filter by whether the custom hostname is a wildcard hostname. ### Returns - `CustomHostnameListResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const customHostnameListResponse of client.customHostnames.list({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', })) { console.log(customHostnameListResponse.id); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "id": "023e105f4ecef8ad9ca31a8372d0c353", "hostname": "app.example.com", "created_at": "2020-02-06T18:11:23.531995Z", "custom_metadata": { "foo": "string" }, "custom_origin_server": "origin2.example.com", "custom_origin_sni": "sni.example.com", "ownership_verification": { "name": "_cf-custom-hostname.app.example.com", "type": "txt", "value": "5cc07c04-ea62-4a5a-95f0-419334a875a4" }, "ownership_verification_http": { "http_body": "5cc07c04-ea62-4a5a-95f0-419334a875a4", "http_url": "http://custom.test.com/.well-known/cf-custom-hostname-challenge/0d89c70d-ad9f-4843-b99f-6cc0252067e9" }, "ssl": { "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9", "bundle_method": "ubiquitous", "certificate_authority": "google", "custom_certificate": "-----BEGIN CERTIFICATE-----\nMIIFJDCCBAygAwIBAgIQD0ifmj/Yi5NP/2gdUySbfzANBgkqhkiG9w0BAQsFADBN\nMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMScwJQYDVQQDEx5E...SzSHfXp5lnu/3V08I72q1QNzOCgY1XeL4GKVcj4or6cT6tX6oJH7ePPmfrBfqI/O\nOeH8gMJ+FuwtXYEPa4hBf38M5eU5xWG7\n-----END CERTIFICATE-----\n", "custom_csr_id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752", "custom_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAwQHoetcl9+5ikGzV6cMzWtWPJHqXT3wpbEkRU9Yz7lgvddmG\ndtcGbg/1CGZu0jJGkMoppoUo4c3dts3iwqRYmBikUP77wwY2QGmDZw2FvkJCJlKn\nabIRuGvBKwzESIXgKk2016aTP6/dAjEHyo6SeoK8lkIySUvK0fyOVlsiEsCmOpid\ntnKX/a+50GjB79CJH4ER2lLVZnhePFR/zUOyPxZQQ4naHf7yu/b5jhO0f8fwt+py\nFxIXjbEIdZliWRkRMtzrHOJIhrmJ2A1J7iOrirbbwillwjjNVUWPf3IJ3M12S9pE\newooaeO2izNTERcG9HzAacbVRn2Y2SWIyT/18QIDAQABAoIBACbhTYXBZYKmYPCb\nHBR1IBlCQA2nLGf0qRuJNJZg5iEzXows/6tc8YymZkQE7nolapWsQ+upk2y5Xdp/\naxiuprIs9JzkYK8Ox0r+dlwCG1kSW+UAbX0bQ/qUqlsTvU6muVuMP8vZYHxJ3wmb\n+ufRBKztPTQ/rYWaYQcgC0RWI20HTFBMxlTAyNxYNWzX7RKFkGVVyB9RsAtmcc8g\n+j4OdosbfNoJPS0HeIfNpAznDfHKdxDk2Yc1tV6RHBrC1ynyLE9+TaflIAdo2MVv\nKLMLq51GqYKtgJFIlBRPQqKoyXdz3fGvXrTkf/WY9QNq0J1Vk5ERePZ54mN8iZB7\n9lwy/AkCgYEA6FXzosxswaJ2wQLeoYc7ceaweX/SwTvxHgXzRyJIIT0eJWgx13Wo\n/WA3Iziimsjf6qE+SI/8laxPp2A86VMaIt3Z3mJN/CqSVGw8LK2AQst+OwdPyDMu\niacE8lj/IFGC8mwNUAb9CzGU3JpU4PxxGFjS/eMtGeRXCWkK4NE+G08CgYEA1Kp9\nN2JrVlqUz+gAX+LPmE9OEMAS9WQSQsfCHGogIFDGGcNf7+uwBM7GAaSJIP01zcoe\nVAgWdzXCv3FLhsaZoJ6RyLOLay5phbu1iaTr4UNYm5WtYTzMzqh8l1+MFFDl9xDB\nvULuCIIrglM5MeS/qnSg1uMoH2oVPj9TVst/ir8CgYEAxrI7Ws9Zc4Bt70N1As+U\nlySjaEVZCMkqvHJ6TCuVZFfQoE0r0whdLdRLU2PsLFP+q7qaeZQqgBaNSKeVcDYR\n9B+nY/jOmQoPewPVsp/vQTCnE/R81spu0mp0YI6cIheT1Z9zAy322svcc43JaWB7\nmEbeqyLOP4Z4qSOcmghZBSECgYACvR9Xs0DGn+wCsW4vze/2ei77MD4OQvepPIFX\ndFZtlBy5ADcgE9z0cuVB6CiL8DbdK5kwY9pGNr8HUCI03iHkW6Zs+0L0YmihfEVe\nPG19PSzK9CaDdhD9KFZSbLyVFmWfxOt50H7YRTTiPMgjyFpfi5j2q348yVT0tEQS\nfhRqaQKBgAcWPokmJ7EbYQGeMbS7HC8eWO/RyamlnSffdCdSc7ue3zdVJxpAkQ8W\nqu80pEIF6raIQfAf8MXiiZ7auFOSnHQTXUbhCpvDLKi0Mwq3G8Pl07l+2s6dQG6T\nlv6XTQaMyf6n1yjzL+fzDrH3qXMxHMO/b13EePXpDMpY7HQpoLDi\n-----END RSA PRIVATE KEY-----\n", "dcv_delegation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "expires_on": "2021-02-06T18:11:23.531995Z", "hosts": [ "app.example.com", "*.app.example.com" ], "issuer": "DigiCertInc", "method": "http", "serial_number": "6743787633689793699141714808227354901", "settings": { "ciphers": [ "ECDHE-RSA-AES128-GCM-SHA256", "AES128-SHA" ], "early_hints": "on", "http2": "on", "min_tls_version": "1.2", "tls_1_3": "on" }, "signature": "SHA256WithRSA", "status": "pending_validation", "type": "dv", "uploaded_on": "2020-02-06T18:11:23.531995Z", "validation_errors": [ { "message": "SERVFAIL looking up CAA for app.example.com" } ], "validation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "wildcard": false }, "status": "pending", "verification_errors": [ "None of the A or AAAA records are owned by this account and the pre-generated ownership verification token was not found." ] } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ``` ## Custom Hostname Details `client.customHostnames.get(stringcustomHostnameId, CustomHostnameGetParamsparams, RequestOptionsoptions?): CustomHostnameGetResponse` **get** `/zones/{zone_id}/custom_hostnames/{custom_hostname_id}` Retrieves detailed information about a specific custom hostname, including SSL certificate status, ownership verification, and origin configuration. ### Parameters - `customHostnameId: string` Identifier. - `params: CustomHostnameGetParams` - `zone_id: string` Identifier. ### Returns - `CustomHostnameGetResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const customHostname = await client.customHostnames.get('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(customHostname.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "hostname": "app.example.com", "created_at": "2020-02-06T18:11:23.531995Z", "custom_metadata": { "foo": "string" }, "custom_origin_server": "origin2.example.com", "custom_origin_sni": "sni.example.com", "ownership_verification": { "name": "_cf-custom-hostname.app.example.com", "type": "txt", "value": "5cc07c04-ea62-4a5a-95f0-419334a875a4" }, "ownership_verification_http": { "http_body": "5cc07c04-ea62-4a5a-95f0-419334a875a4", "http_url": "http://custom.test.com/.well-known/cf-custom-hostname-challenge/0d89c70d-ad9f-4843-b99f-6cc0252067e9" }, "ssl": { "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9", "bundle_method": "ubiquitous", "certificate_authority": "google", "custom_certificate": "-----BEGIN CERTIFICATE-----\nMIIFJDCCBAygAwIBAgIQD0ifmj/Yi5NP/2gdUySbfzANBgkqhkiG9w0BAQsFADBN\nMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMScwJQYDVQQDEx5E...SzSHfXp5lnu/3V08I72q1QNzOCgY1XeL4GKVcj4or6cT6tX6oJH7ePPmfrBfqI/O\nOeH8gMJ+FuwtXYEPa4hBf38M5eU5xWG7\n-----END CERTIFICATE-----\n", "custom_csr_id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752", "custom_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAwQHoetcl9+5ikGzV6cMzWtWPJHqXT3wpbEkRU9Yz7lgvddmG\ndtcGbg/1CGZu0jJGkMoppoUo4c3dts3iwqRYmBikUP77wwY2QGmDZw2FvkJCJlKn\nabIRuGvBKwzESIXgKk2016aTP6/dAjEHyo6SeoK8lkIySUvK0fyOVlsiEsCmOpid\ntnKX/a+50GjB79CJH4ER2lLVZnhePFR/zUOyPxZQQ4naHf7yu/b5jhO0f8fwt+py\nFxIXjbEIdZliWRkRMtzrHOJIhrmJ2A1J7iOrirbbwillwjjNVUWPf3IJ3M12S9pE\newooaeO2izNTERcG9HzAacbVRn2Y2SWIyT/18QIDAQABAoIBACbhTYXBZYKmYPCb\nHBR1IBlCQA2nLGf0qRuJNJZg5iEzXows/6tc8YymZkQE7nolapWsQ+upk2y5Xdp/\naxiuprIs9JzkYK8Ox0r+dlwCG1kSW+UAbX0bQ/qUqlsTvU6muVuMP8vZYHxJ3wmb\n+ufRBKztPTQ/rYWaYQcgC0RWI20HTFBMxlTAyNxYNWzX7RKFkGVVyB9RsAtmcc8g\n+j4OdosbfNoJPS0HeIfNpAznDfHKdxDk2Yc1tV6RHBrC1ynyLE9+TaflIAdo2MVv\nKLMLq51GqYKtgJFIlBRPQqKoyXdz3fGvXrTkf/WY9QNq0J1Vk5ERePZ54mN8iZB7\n9lwy/AkCgYEA6FXzosxswaJ2wQLeoYc7ceaweX/SwTvxHgXzRyJIIT0eJWgx13Wo\n/WA3Iziimsjf6qE+SI/8laxPp2A86VMaIt3Z3mJN/CqSVGw8LK2AQst+OwdPyDMu\niacE8lj/IFGC8mwNUAb9CzGU3JpU4PxxGFjS/eMtGeRXCWkK4NE+G08CgYEA1Kp9\nN2JrVlqUz+gAX+LPmE9OEMAS9WQSQsfCHGogIFDGGcNf7+uwBM7GAaSJIP01zcoe\nVAgWdzXCv3FLhsaZoJ6RyLOLay5phbu1iaTr4UNYm5WtYTzMzqh8l1+MFFDl9xDB\nvULuCIIrglM5MeS/qnSg1uMoH2oVPj9TVst/ir8CgYEAxrI7Ws9Zc4Bt70N1As+U\nlySjaEVZCMkqvHJ6TCuVZFfQoE0r0whdLdRLU2PsLFP+q7qaeZQqgBaNSKeVcDYR\n9B+nY/jOmQoPewPVsp/vQTCnE/R81spu0mp0YI6cIheT1Z9zAy322svcc43JaWB7\nmEbeqyLOP4Z4qSOcmghZBSECgYACvR9Xs0DGn+wCsW4vze/2ei77MD4OQvepPIFX\ndFZtlBy5ADcgE9z0cuVB6CiL8DbdK5kwY9pGNr8HUCI03iHkW6Zs+0L0YmihfEVe\nPG19PSzK9CaDdhD9KFZSbLyVFmWfxOt50H7YRTTiPMgjyFpfi5j2q348yVT0tEQS\nfhRqaQKBgAcWPokmJ7EbYQGeMbS7HC8eWO/RyamlnSffdCdSc7ue3zdVJxpAkQ8W\nqu80pEIF6raIQfAf8MXiiZ7auFOSnHQTXUbhCpvDLKi0Mwq3G8Pl07l+2s6dQG6T\nlv6XTQaMyf6n1yjzL+fzDrH3qXMxHMO/b13EePXpDMpY7HQpoLDi\n-----END RSA PRIVATE KEY-----\n", "dcv_delegation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "expires_on": "2021-02-06T18:11:23.531995Z", "hosts": [ "app.example.com", "*.app.example.com" ], "issuer": "DigiCertInc", "method": "http", "serial_number": "6743787633689793699141714808227354901", "settings": { "ciphers": [ "ECDHE-RSA-AES128-GCM-SHA256", "AES128-SHA" ], "early_hints": "on", "http2": "on", "min_tls_version": "1.2", "tls_1_3": "on" }, "signature": "SHA256WithRSA", "status": "pending_validation", "type": "dv", "uploaded_on": "2020-02-06T18:11:23.531995Z", "validation_errors": [ { "message": "SERVFAIL looking up CAA for app.example.com" } ], "validation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "wildcard": false }, "status": "pending", "verification_errors": [ "None of the A or AAAA records are owned by this account and the pre-generated ownership verification token was not found." ] } } ``` ## Create Custom Hostname `client.customHostnames.create(CustomHostnameCreateParamsparams, RequestOptionsoptions?): CustomHostnameCreateResponse` **post** `/zones/{zone_id}/custom_hostnames` Add a new custom hostname and request that an SSL certificate be issued for it. One of three validation methods—http, txt, email—should be used, with 'http' recommended if the CNAME is already in place (or will be soon). Specifying 'email' will send an email to the WHOIS contacts on file for the base domain plus hostmaster, postmaster, webmaster, admin, administrator. If http is used and the domain is not already pointing to the Managed CNAME host, the PATCH method must be used once it is (to complete validation). Enable bundling of certificates using the custom_cert_bundle field. The bundling process requires the following condition One certificate in the bundle must use an RSA, and the other must use an ECDSA. ### Parameters - `params: CustomHostnameCreateParams` - `zone_id: string` Path param: Identifier. - `hostname: string` Body param: The custom hostname that will point to your hostname via CNAME. - `custom_metadata?: Record` Body param: Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `ssl?: SSL` Body param: SSL properties used when creating the custom hostname. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `cloudflare_branding?: boolean` Whether or not to add Cloudflare Branding for the order. This will add a subdomain of sni.cloudflaressl.com as the Common Name if set to true - `custom_cert_bundle?: Array` Array of custom certificate and key pairs (1 or 2 pairs allowed) - `custom_certificate: string` If a custom uploaded certificate is used. - `custom_key: string` The key for a custom uploaded certificate. - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `settings?: Settings` SSL specific settings. - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. ### Returns - `CustomHostnameCreateResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const customHostname = await client.customHostnames.create({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', hostname: 'app.example.com', }); console.log(customHostname.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "hostname": "app.example.com", "created_at": "2020-02-06T18:11:23.531995Z", "custom_metadata": { "foo": "string" }, "custom_origin_server": "origin2.example.com", "custom_origin_sni": "sni.example.com", "ownership_verification": { "name": "_cf-custom-hostname.app.example.com", "type": "txt", "value": "5cc07c04-ea62-4a5a-95f0-419334a875a4" }, "ownership_verification_http": { "http_body": "5cc07c04-ea62-4a5a-95f0-419334a875a4", "http_url": "http://custom.test.com/.well-known/cf-custom-hostname-challenge/0d89c70d-ad9f-4843-b99f-6cc0252067e9" }, "ssl": { "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9", "bundle_method": "ubiquitous", "certificate_authority": "google", "custom_certificate": "-----BEGIN CERTIFICATE-----\nMIIFJDCCBAygAwIBAgIQD0ifmj/Yi5NP/2gdUySbfzANBgkqhkiG9w0BAQsFADBN\nMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMScwJQYDVQQDEx5E...SzSHfXp5lnu/3V08I72q1QNzOCgY1XeL4GKVcj4or6cT6tX6oJH7ePPmfrBfqI/O\nOeH8gMJ+FuwtXYEPa4hBf38M5eU5xWG7\n-----END CERTIFICATE-----\n", "custom_csr_id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752", "custom_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAwQHoetcl9+5ikGzV6cMzWtWPJHqXT3wpbEkRU9Yz7lgvddmG\ndtcGbg/1CGZu0jJGkMoppoUo4c3dts3iwqRYmBikUP77wwY2QGmDZw2FvkJCJlKn\nabIRuGvBKwzESIXgKk2016aTP6/dAjEHyo6SeoK8lkIySUvK0fyOVlsiEsCmOpid\ntnKX/a+50GjB79CJH4ER2lLVZnhePFR/zUOyPxZQQ4naHf7yu/b5jhO0f8fwt+py\nFxIXjbEIdZliWRkRMtzrHOJIhrmJ2A1J7iOrirbbwillwjjNVUWPf3IJ3M12S9pE\newooaeO2izNTERcG9HzAacbVRn2Y2SWIyT/18QIDAQABAoIBACbhTYXBZYKmYPCb\nHBR1IBlCQA2nLGf0qRuJNJZg5iEzXows/6tc8YymZkQE7nolapWsQ+upk2y5Xdp/\naxiuprIs9JzkYK8Ox0r+dlwCG1kSW+UAbX0bQ/qUqlsTvU6muVuMP8vZYHxJ3wmb\n+ufRBKztPTQ/rYWaYQcgC0RWI20HTFBMxlTAyNxYNWzX7RKFkGVVyB9RsAtmcc8g\n+j4OdosbfNoJPS0HeIfNpAznDfHKdxDk2Yc1tV6RHBrC1ynyLE9+TaflIAdo2MVv\nKLMLq51GqYKtgJFIlBRPQqKoyXdz3fGvXrTkf/WY9QNq0J1Vk5ERePZ54mN8iZB7\n9lwy/AkCgYEA6FXzosxswaJ2wQLeoYc7ceaweX/SwTvxHgXzRyJIIT0eJWgx13Wo\n/WA3Iziimsjf6qE+SI/8laxPp2A86VMaIt3Z3mJN/CqSVGw8LK2AQst+OwdPyDMu\niacE8lj/IFGC8mwNUAb9CzGU3JpU4PxxGFjS/eMtGeRXCWkK4NE+G08CgYEA1Kp9\nN2JrVlqUz+gAX+LPmE9OEMAS9WQSQsfCHGogIFDGGcNf7+uwBM7GAaSJIP01zcoe\nVAgWdzXCv3FLhsaZoJ6RyLOLay5phbu1iaTr4UNYm5WtYTzMzqh8l1+MFFDl9xDB\nvULuCIIrglM5MeS/qnSg1uMoH2oVPj9TVst/ir8CgYEAxrI7Ws9Zc4Bt70N1As+U\nlySjaEVZCMkqvHJ6TCuVZFfQoE0r0whdLdRLU2PsLFP+q7qaeZQqgBaNSKeVcDYR\n9B+nY/jOmQoPewPVsp/vQTCnE/R81spu0mp0YI6cIheT1Z9zAy322svcc43JaWB7\nmEbeqyLOP4Z4qSOcmghZBSECgYACvR9Xs0DGn+wCsW4vze/2ei77MD4OQvepPIFX\ndFZtlBy5ADcgE9z0cuVB6CiL8DbdK5kwY9pGNr8HUCI03iHkW6Zs+0L0YmihfEVe\nPG19PSzK9CaDdhD9KFZSbLyVFmWfxOt50H7YRTTiPMgjyFpfi5j2q348yVT0tEQS\nfhRqaQKBgAcWPokmJ7EbYQGeMbS7HC8eWO/RyamlnSffdCdSc7ue3zdVJxpAkQ8W\nqu80pEIF6raIQfAf8MXiiZ7auFOSnHQTXUbhCpvDLKi0Mwq3G8Pl07l+2s6dQG6T\nlv6XTQaMyf6n1yjzL+fzDrH3qXMxHMO/b13EePXpDMpY7HQpoLDi\n-----END RSA PRIVATE KEY-----\n", "dcv_delegation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "expires_on": "2021-02-06T18:11:23.531995Z", "hosts": [ "app.example.com", "*.app.example.com" ], "issuer": "DigiCertInc", "method": "http", "serial_number": "6743787633689793699141714808227354901", "settings": { "ciphers": [ "ECDHE-RSA-AES128-GCM-SHA256", "AES128-SHA" ], "early_hints": "on", "http2": "on", "min_tls_version": "1.2", "tls_1_3": "on" }, "signature": "SHA256WithRSA", "status": "pending_validation", "type": "dv", "uploaded_on": "2020-02-06T18:11:23.531995Z", "validation_errors": [ { "message": "SERVFAIL looking up CAA for app.example.com" } ], "validation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "wildcard": false }, "status": "pending", "verification_errors": [ "None of the A or AAAA records are owned by this account and the pre-generated ownership verification token was not found." ] } } ``` ## Edit Custom Hostname `client.customHostnames.edit(stringcustomHostnameId, CustomHostnameEditParamsparams, RequestOptionsoptions?): CustomHostnameEditResponse` **patch** `/zones/{zone_id}/custom_hostnames/{custom_hostname_id}` Modify SSL configuration for a custom hostname. When sent with SSL config that matches existing config, used to indicate that hostname should pass domain control validation (DCV). Can also be used to change validation type, e.g., from 'http' to 'email'. Bundle an existing certificate with another certificate by using the "custom_cert_bundle" field. The bundling process supports combining certificates as long as the following condition is met. One certificate must use the RSA algorithm, and the other must use the ECDSA algorithm. ### Parameters - `customHostnameId: string` Identifier. - `params: CustomHostnameEditParams` - `zone_id: string` Path param: Identifier. - `custom_metadata?: Record` Body param: Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` Body param: a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` Body param: A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ssl?: SSL` Body param: SSL properties used when creating the custom hostname. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `cloudflare_branding?: boolean` Whether or not to add Cloudflare Branding for the order. This will add a subdomain of sni.cloudflaressl.com as the Common Name if set to true - `custom_cert_bundle?: Array` Array of custom certificate and key pairs (1 or 2 pairs allowed) - `custom_certificate: string` If a custom uploaded certificate is used. - `custom_key: string` The key for a custom uploaded certificate. - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `settings?: Settings` SSL specific settings. - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. ### Returns - `CustomHostnameEditResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.customHostnames.edit('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(response.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "hostname": "app.example.com", "created_at": "2020-02-06T18:11:23.531995Z", "custom_metadata": { "foo": "string" }, "custom_origin_server": "origin2.example.com", "custom_origin_sni": "sni.example.com", "ownership_verification": { "name": "_cf-custom-hostname.app.example.com", "type": "txt", "value": "5cc07c04-ea62-4a5a-95f0-419334a875a4" }, "ownership_verification_http": { "http_body": "5cc07c04-ea62-4a5a-95f0-419334a875a4", "http_url": "http://custom.test.com/.well-known/cf-custom-hostname-challenge/0d89c70d-ad9f-4843-b99f-6cc0252067e9" }, "ssl": { "id": "0d89c70d-ad9f-4843-b99f-6cc0252067e9", "bundle_method": "ubiquitous", "certificate_authority": "google", "custom_certificate": "-----BEGIN CERTIFICATE-----\nMIIFJDCCBAygAwIBAgIQD0ifmj/Yi5NP/2gdUySbfzANBgkqhkiG9w0BAQsFADBN\nMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMScwJQYDVQQDEx5E...SzSHfXp5lnu/3V08I72q1QNzOCgY1XeL4GKVcj4or6cT6tX6oJH7ePPmfrBfqI/O\nOeH8gMJ+FuwtXYEPa4hBf38M5eU5xWG7\n-----END CERTIFICATE-----\n", "custom_csr_id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752", "custom_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEowIBAAKCAQEAwQHoetcl9+5ikGzV6cMzWtWPJHqXT3wpbEkRU9Yz7lgvddmG\ndtcGbg/1CGZu0jJGkMoppoUo4c3dts3iwqRYmBikUP77wwY2QGmDZw2FvkJCJlKn\nabIRuGvBKwzESIXgKk2016aTP6/dAjEHyo6SeoK8lkIySUvK0fyOVlsiEsCmOpid\ntnKX/a+50GjB79CJH4ER2lLVZnhePFR/zUOyPxZQQ4naHf7yu/b5jhO0f8fwt+py\nFxIXjbEIdZliWRkRMtzrHOJIhrmJ2A1J7iOrirbbwillwjjNVUWPf3IJ3M12S9pE\newooaeO2izNTERcG9HzAacbVRn2Y2SWIyT/18QIDAQABAoIBACbhTYXBZYKmYPCb\nHBR1IBlCQA2nLGf0qRuJNJZg5iEzXows/6tc8YymZkQE7nolapWsQ+upk2y5Xdp/\naxiuprIs9JzkYK8Ox0r+dlwCG1kSW+UAbX0bQ/qUqlsTvU6muVuMP8vZYHxJ3wmb\n+ufRBKztPTQ/rYWaYQcgC0RWI20HTFBMxlTAyNxYNWzX7RKFkGVVyB9RsAtmcc8g\n+j4OdosbfNoJPS0HeIfNpAznDfHKdxDk2Yc1tV6RHBrC1ynyLE9+TaflIAdo2MVv\nKLMLq51GqYKtgJFIlBRPQqKoyXdz3fGvXrTkf/WY9QNq0J1Vk5ERePZ54mN8iZB7\n9lwy/AkCgYEA6FXzosxswaJ2wQLeoYc7ceaweX/SwTvxHgXzRyJIIT0eJWgx13Wo\n/WA3Iziimsjf6qE+SI/8laxPp2A86VMaIt3Z3mJN/CqSVGw8LK2AQst+OwdPyDMu\niacE8lj/IFGC8mwNUAb9CzGU3JpU4PxxGFjS/eMtGeRXCWkK4NE+G08CgYEA1Kp9\nN2JrVlqUz+gAX+LPmE9OEMAS9WQSQsfCHGogIFDGGcNf7+uwBM7GAaSJIP01zcoe\nVAgWdzXCv3FLhsaZoJ6RyLOLay5phbu1iaTr4UNYm5WtYTzMzqh8l1+MFFDl9xDB\nvULuCIIrglM5MeS/qnSg1uMoH2oVPj9TVst/ir8CgYEAxrI7Ws9Zc4Bt70N1As+U\nlySjaEVZCMkqvHJ6TCuVZFfQoE0r0whdLdRLU2PsLFP+q7qaeZQqgBaNSKeVcDYR\n9B+nY/jOmQoPewPVsp/vQTCnE/R81spu0mp0YI6cIheT1Z9zAy322svcc43JaWB7\nmEbeqyLOP4Z4qSOcmghZBSECgYACvR9Xs0DGn+wCsW4vze/2ei77MD4OQvepPIFX\ndFZtlBy5ADcgE9z0cuVB6CiL8DbdK5kwY9pGNr8HUCI03iHkW6Zs+0L0YmihfEVe\nPG19PSzK9CaDdhD9KFZSbLyVFmWfxOt50H7YRTTiPMgjyFpfi5j2q348yVT0tEQS\nfhRqaQKBgAcWPokmJ7EbYQGeMbS7HC8eWO/RyamlnSffdCdSc7ue3zdVJxpAkQ8W\nqu80pEIF6raIQfAf8MXiiZ7auFOSnHQTXUbhCpvDLKi0Mwq3G8Pl07l+2s6dQG6T\nlv6XTQaMyf6n1yjzL+fzDrH3qXMxHMO/b13EePXpDMpY7HQpoLDi\n-----END RSA PRIVATE KEY-----\n", "dcv_delegation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "expires_on": "2021-02-06T18:11:23.531995Z", "hosts": [ "app.example.com", "*.app.example.com" ], "issuer": "DigiCertInc", "method": "http", "serial_number": "6743787633689793699141714808227354901", "settings": { "ciphers": [ "ECDHE-RSA-AES128-GCM-SHA256", "AES128-SHA" ], "early_hints": "on", "http2": "on", "min_tls_version": "1.2", "tls_1_3": "on" }, "signature": "SHA256WithRSA", "status": "pending_validation", "type": "dv", "uploaded_on": "2020-02-06T18:11:23.531995Z", "validation_errors": [ { "message": "SERVFAIL looking up CAA for app.example.com" } ], "validation_records": [ { "cname": "_acme-challenge.example.com", "cname_target": "dcv.cloudflare.com", "emails": [ "administrator@example.com", "webmaster@example.com" ], "http_body": "ca3-574923932a82475cb8592200f1a2a23d", "http_url": "http://app.example.com/.well-known/pki-validation/ca3-da12a1c25e7b48cf80408c6c1763b8a2.txt", "status": "pending", "txt_name": "_acme-challenge.app.example.com", "txt_value": "810b7d5f01154524b961ba0cd578acc2" } ], "wildcard": false }, "status": "pending", "verification_errors": [ "None of the A or AAAA records are owned by this account and the pre-generated ownership verification token was not found." ] } } ``` ## Delete Custom Hostname (and any issued SSL certificates) `client.customHostnames.delete(stringcustomHostnameId, CustomHostnameDeleteParamsparams, RequestOptionsoptions?): CustomHostnameDeleteResponse` **delete** `/zones/{zone_id}/custom_hostnames/{custom_hostname_id}` Permanently deletes a custom hostname and revokes any SSL certificates that were issued for it. This action cannot be undone. ### Parameters - `customHostnameId: string` Identifier. - `params: CustomHostnameDeleteParams` - `zone_id: string` Identifier. ### Returns - `CustomHostnameDeleteResponse` - `id?: string` Identifier. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const customHostname = await client.customHostnames.delete('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(customHostname.id); ``` #### Response ```json { "id": "023e105f4ecef8ad9ca31a8372d0c353" } ``` ## Domain Types ### Bundle Method - `BundleMethod = "ubiquitous" | "optimal" | "force"` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` ### Custom Hostname - `CustomHostname` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### DCV Method - `DCVMethod = "http" | "txt" | "email"` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` ### Domain Validation Type - `DomainValidationType = "dv"` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` ### Custom Hostname List Response - `CustomHostnameListResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Custom Hostname Get Response - `CustomHostnameGetResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Custom Hostname Create Response - `CustomHostnameCreateResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Custom Hostname Edit Response - `CustomHostnameEditResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Record type. - `"txt"` - `value?: string` Content for the record. - `ownership_verification_http?: OwnershipVerificationHTTP` This presents the token to be served by the given http url to activate a hostname. - `http_body?: string` Token to be served. - `http_url?: string` The HTTP URL that will be checked during custom hostname verification and where the customer should host the token. - `ssl?: SSL` - `id?: string` Custom hostname SSL identifier tag. - `bundle_method?: BundleMethod` A ubiquitous bundle has the highest probability of being verified everywhere, even by clients using outdated or unusual trust stores. An optimal bundle uses the shortest chain and newest intermediates. And the force bundle verifies the chain, but does not otherwise modify it. - `"ubiquitous"` - `"optimal"` - `"force"` - `certificate_authority?: CertificateCA` The Certificate Authority that will issue the certificate - `"digicert"` - `"google"` - `"lets_encrypt"` - `"ssl_com"` - `custom_certificate?: string` If a custom uploaded certificate is used. - `custom_csr_id?: string` The identifier for the Custom CSR that was used. - `custom_key?: string` The key for a custom uploaded certificate. - `dcv_delegation_records?: Array` DCV Delegation records for domain validation. - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `expires_on?: string` The time the custom certificate expires on. - `hosts?: Array` A list of Hostnames on a custom uploaded certificate. - `issuer?: string` The issuer on a custom uploaded certificate. - `method?: DCVMethod` Domain control validation (DCV) method used for this hostname. - `"http"` - `"txt"` - `"email"` - `serial_number?: string` The serial number on a custom uploaded certificate. - `settings?: Settings` - `ciphers?: Array` An allowlist of ciphers for TLS termination. These ciphers must be in the BoringSSL format. - `early_hints?: "on" | "off"` Whether or not Early Hints is enabled. - `"on"` - `"off"` - `http2?: "on" | "off"` Whether or not HTTP2 is enabled. - `"on"` - `"off"` - `min_tls_version?: "1.0" | "1.1" | "1.2" | "1.3"` The minimum TLS version supported. - `"1.0"` - `"1.1"` - `"1.2"` - `"1.3"` - `tls_1_3?: "on" | "off"` Whether or not TLS 1.3 is enabled. - `"on"` - `"off"` - `signature?: string` The signature on a custom uploaded certificate. - `status?: "initializing" | "pending_validation" | "deleted" | 18 more` Status of the hostname's SSL certificates. - `"initializing"` - `"pending_validation"` - `"deleted"` - `"pending_issuance"` - `"pending_deployment"` - `"pending_deletion"` - `"pending_expiration"` - `"expired"` - `"active"` - `"initializing_timed_out"` - `"validation_timed_out"` - `"issuance_timed_out"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `"pending_cleanup"` - `"staging_deployment"` - `"staging_active"` - `"deactivating"` - `"inactive"` - `"backup_issued"` - `"holding_deployment"` - `type?: DomainValidationType` Level of validation to be used for this hostname. Domain validation (dv) must be used. - `"dv"` - `uploaded_on?: string` The time the custom certificate was uploaded. - `validation_errors?: Array` Domain validation errors that have been received by the certificate authority (CA). - `message?: string` A domain validation error. - `validation_records?: Array` - `cname?: string` The CNAME record hostname for DCV delegation. - `cname_target?: string` The CNAME record target value for DCV delegation. - `emails?: Array` The set of email addresses that the certificate authority (CA) will use to complete domain validation. - `http_body?: string` The content that the certificate authority (CA) will expect to find at the http_url during the domain validation. - `http_url?: string` The url that will be checked during domain validation. - `status?: string` Status of the validation record. - `txt_name?: string` The hostname that the certificate authority (CA) will check for a TXT record during domain validation . - `txt_value?: string` The TXT record that the certificate authority (CA) will check during domain validation. - `wildcard?: boolean` Indicates whether the certificate covers a wildcard. - `status?: "active" | "pending" | "active_redeploying" | 13 more` Status of the hostname's activation. - `"active"` - `"pending"` - `"active_redeploying"` - `"moved"` - `"pending_deletion"` - `"deleted"` - `"pending_blocked"` - `"pending_migration"` - `"pending_provisioned"` - `"test_pending"` - `"test_active"` - `"test_active_apex"` - `"test_blocked"` - `"test_failed"` - `"provisioned"` - `"blocked"` - `verification_errors?: Array` These are errors that were encountered while trying to activate a hostname. ### Custom Hostname Delete Response - `CustomHostnameDeleteResponse` - `id?: string` Identifier. # Fallback Origin ## Get Fallback Origin for Custom Hostnames `client.customHostnames.fallbackOrigin.get(FallbackOriginGetParamsparams, RequestOptionsoptions?): FallbackOriginGetResponse` **get** `/zones/{zone_id}/custom_hostnames/fallback_origin` Retrieves the current fallback origin configuration for custom hostnames on a zone. The fallback origin handles traffic when specific custom hostname origins are unavailable. ### Parameters - `params: FallbackOriginGetParams` - `zone_id: string` Identifier. ### Returns - `FallbackOriginGetResponse` - `created_at?: string` This is the time the fallback origin was created. - `errors?: Array` These are errors that were encountered while trying to activate a fallback origin. - `origin?: string` Your origin hostname that requests to your custom hostnames will be sent to. - `status?: "initializing" | "pending_deployment" | "pending_deletion" | 3 more` Status of the fallback origin's activation. - `"initializing"` - `"pending_deployment"` - `"pending_deletion"` - `"active"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `updated_at?: string` This is the time the fallback origin was updated. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const fallbackOrigin = await client.customHostnames.fallbackOrigin.get({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(fallbackOrigin.created_at); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "created_at": "2019-10-28T18:11:23.37411Z", "errors": [ "DNS records are not setup correctly. Origin should be a proxied A/AAAA/CNAME dns record" ], "origin": "fallback.example.com", "status": "pending_deployment", "updated_at": "2020-03-16T18:11:23.531995Z" } } ``` ## Update Fallback Origin for Custom Hostnames `client.customHostnames.fallbackOrigin.update(FallbackOriginUpdateParamsparams, RequestOptionsoptions?): FallbackOriginUpdateResponse` **put** `/zones/{zone_id}/custom_hostnames/fallback_origin` Updates the fallback origin configuration for custom hostnames on a zone. Sets the default origin server for custom hostname traffic. ### Parameters - `params: FallbackOriginUpdateParams` - `zone_id: string` Path param: Identifier. - `origin: string` Body param: Your origin hostname that requests to your custom hostnames will be sent to. ### Returns - `FallbackOriginUpdateResponse` - `created_at?: string` This is the time the fallback origin was created. - `errors?: Array` These are errors that were encountered while trying to activate a fallback origin. - `origin?: string` Your origin hostname that requests to your custom hostnames will be sent to. - `status?: "initializing" | "pending_deployment" | "pending_deletion" | 3 more` Status of the fallback origin's activation. - `"initializing"` - `"pending_deployment"` - `"pending_deletion"` - `"active"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `updated_at?: string` This is the time the fallback origin was updated. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const fallbackOrigin = await client.customHostnames.fallbackOrigin.update({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', origin: 'fallback.example.com', }); console.log(fallbackOrigin.created_at); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "created_at": "2019-10-28T18:11:23.37411Z", "errors": [ "DNS records are not setup correctly. Origin should be a proxied A/AAAA/CNAME dns record" ], "origin": "fallback.example.com", "status": "pending_deployment", "updated_at": "2020-03-16T18:11:23.531995Z" } } ``` ## Delete Fallback Origin for Custom Hostnames `client.customHostnames.fallbackOrigin.delete(FallbackOriginDeleteParamsparams, RequestOptionsoptions?): FallbackOriginDeleteResponse` **delete** `/zones/{zone_id}/custom_hostnames/fallback_origin` Removes the fallback origin configuration for custom hostnames on a zone. Custom hostnames without specific origins will no longer have a fallback. ### Parameters - `params: FallbackOriginDeleteParams` - `zone_id: string` Identifier. ### Returns - `FallbackOriginDeleteResponse` - `created_at?: string` This is the time the fallback origin was created. - `errors?: Array` These are errors that were encountered while trying to activate a fallback origin. - `origin?: string` Your origin hostname that requests to your custom hostnames will be sent to. - `status?: "initializing" | "pending_deployment" | "pending_deletion" | 3 more` Status of the fallback origin's activation. - `"initializing"` - `"pending_deployment"` - `"pending_deletion"` - `"active"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `updated_at?: string` This is the time the fallback origin was updated. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const fallbackOrigin = await client.customHostnames.fallbackOrigin.delete({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(fallbackOrigin.created_at); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "created_at": "2019-10-28T18:11:23.37411Z", "errors": [ "DNS records are not setup correctly. Origin should be a proxied A/AAAA/CNAME dns record" ], "origin": "fallback.example.com", "status": "pending_deployment", "updated_at": "2020-03-16T18:11:23.531995Z" } } ``` ## Domain Types ### Fallback Origin Get Response - `FallbackOriginGetResponse` - `created_at?: string` This is the time the fallback origin was created. - `errors?: Array` These are errors that were encountered while trying to activate a fallback origin. - `origin?: string` Your origin hostname that requests to your custom hostnames will be sent to. - `status?: "initializing" | "pending_deployment" | "pending_deletion" | 3 more` Status of the fallback origin's activation. - `"initializing"` - `"pending_deployment"` - `"pending_deletion"` - `"active"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `updated_at?: string` This is the time the fallback origin was updated. ### Fallback Origin Update Response - `FallbackOriginUpdateResponse` - `created_at?: string` This is the time the fallback origin was created. - `errors?: Array` These are errors that were encountered while trying to activate a fallback origin. - `origin?: string` Your origin hostname that requests to your custom hostnames will be sent to. - `status?: "initializing" | "pending_deployment" | "pending_deletion" | 3 more` Status of the fallback origin's activation. - `"initializing"` - `"pending_deployment"` - `"pending_deletion"` - `"active"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `updated_at?: string` This is the time the fallback origin was updated. ### Fallback Origin Delete Response - `FallbackOriginDeleteResponse` - `created_at?: string` This is the time the fallback origin was created. - `errors?: Array` These are errors that were encountered while trying to activate a fallback origin. - `origin?: string` Your origin hostname that requests to your custom hostnames will be sent to. - `status?: "initializing" | "pending_deployment" | "pending_deletion" | 3 more` Status of the fallback origin's activation. - `"initializing"` - `"pending_deployment"` - `"pending_deletion"` - `"active"` - `"deployment_timed_out"` - `"deletion_timed_out"` - `updated_at?: string` This is the time the fallback origin was updated. # Certificate Pack # Certificates ## Replace Custom Certificate and Custom Key In Custom Hostname `client.customHostnames.certificatePack.certificates.update(stringcustomHostnameId, stringcertificatePackId, stringcertificateId, CertificateUpdateParamsparams, RequestOptionsoptions?): CertificateUpdateResponse` **put** `/zones/{zone_id}/custom_hostnames/{custom_hostname_id}/certificate_pack/{certificate_pack_id}/certificates/{certificate_id}` Replace a single custom certificate within a certificate pack that contains two bundled certificates. The replacement must adhere to the following constraints. You can only replace an RSA certificate with another RSA certificate or an ECDSA certificate with another ECDSA certificate. ### Parameters - `customHostnameId: string` Identifier. - `certificatePackId: string` Identifier. - `certificateId: string` Identifier. - `params: CertificateUpdateParams` - `zone_id: string` Path param: Identifier. - `custom_certificate: string` Body param: If a custom uploaded certificate is used. - `custom_key: string` Body param: The key for a custom uploaded certificate. ### Returns - `CertificateUpdateResponse` - `id: string` Identifier. - `hostname: string` The custom hostname that will point to your hostname via CNAME. - `created_at?: string` This is the time the hostname was created. - `custom_metadata?: Record` Unique key/value metadata for this hostname. These are per-hostname (customer) settings. - `custom_origin_server?: string` a valid hostname that’s been added to your DNS zone as an A, AAAA, or CNAME record. - `custom_origin_sni?: string` A hostname that will be sent to your custom origin server as SNI for TLS handshake. This can be a valid subdomain of the zone or custom origin server name or the string ':request_host_header:' which will cause the host header in the request to be used as SNI. Not configurable with default/fallback origin server. - `ownership_verification?: OwnershipVerification` This is a record which can be placed to activate a hostname. - `name?: string` DNS Name for record. - `type?: "txt"` DNS Re
[...]
